# Please Fix!
In [`main.py`](main.py), you will find some code that takes a list of transactions and share prices and prints out the resulting portfolio.

It's terrible code.

We want you to make it more correct, readable and testable.

## Your task

Fork this repository, and make the changes you want to make. When you are done, open a merge/pull request from your fork to this repository. Please make your repository private and grant us permission to read your repository (`reporter` role in GitLab, `read` role in GitHub).


Please spend ideally about 20 minutes making your improvements; we don't want or need a perfect solution, we'd love to see a rough draft of the most important changes after 20 minutes of your time. The improvements should not be limited to refactoring, fix anything that you don't like.

There is no need to add any new files, it's fine to keep the tests in the same module as the code (for now!).

There is a small questionnaire in the `default` merge request template, please take a moment to fill that in.

## Good to know...

* Trust your gut, you don't have to accept anything you don't like, **everything is up for improvement**.
* You are free to use your normal development tools/IDE tools, but please do not use online tools such as ChatGPT for this.
* Please do not spend too much time on this, set a timer! If you wanted to, you could spend hours making this better, there's not need, it won't improve your life in any way. There's more to life than working on this module.
* We don't place too much importance on the outcome of this exercise, it will not decide whether or not you will work with us.
* If possible, please commit (and push) lots of small changes as you make them. That will make it easy to follow the order of the changes you made, which shows us the relative importance of your changes, we would really appreciate that!
* In the end, there is no right answer, there are lots of ways to improve this and anything you do will likely be better than what it was before!
* If you really want to keep going after 20 minutes, fine, we won't stop you. I would suggest spending the next 20 minutes writing more/better tests for your now more testable code.

## This is optional!

This should be fun, if it stops being fun, please stop!
You can opt out of this exercise at any time, just let us know and we'll see what we can do.

## Testing
To run the tests, install pytest and run
```
pytest main.py
```
